/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
)

// checks if the ActivateOrBlockRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActivateOrBlockRequest{}

// ActivateOrBlockRequest struct for ActivateOrBlockRequest
type ActivateOrBlockRequest struct {
	Blocked bool   `json:"blocked"`
	Reason  string `json:"reason"`
}

type _ActivateOrBlockRequest ActivateOrBlockRequest

// NewActivateOrBlockRequest instantiates a new ActivateOrBlockRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActivateOrBlockRequest(blocked bool, reason string) *ActivateOrBlockRequest {
	this := ActivateOrBlockRequest{}
	this.Blocked = blocked
	this.Reason = reason
	return &this
}

// NewActivateOrBlockRequestWithDefaults instantiates a new ActivateOrBlockRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActivateOrBlockRequestWithDefaults() *ActivateOrBlockRequest {
	this := ActivateOrBlockRequest{}
	return &this
}

// GetBlocked returns the Blocked field value
func (o *ActivateOrBlockRequest) GetBlocked() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Blocked
}

// GetBlockedOk returns a tuple with the Blocked field value
// and a boolean to check if the value has been set.
func (o *ActivateOrBlockRequest) GetBlockedOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Blocked, true
}

// SetBlocked sets field value
func (o *ActivateOrBlockRequest) SetBlocked(v bool) {
	o.Blocked = v
}

// GetReason returns the Reason field value
func (o *ActivateOrBlockRequest) GetReason() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Reason
}

// GetReasonOk returns a tuple with the Reason field value
// and a boolean to check if the value has been set.
func (o *ActivateOrBlockRequest) GetReasonOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Reason, true
}

// SetReason sets field value
func (o *ActivateOrBlockRequest) SetReason(v string) {
	o.Reason = v
}

func (o ActivateOrBlockRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActivateOrBlockRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["blocked"] = o.Blocked
	toSerialize["reason"] = o.Reason
	return toSerialize, nil
}

func (o *ActivateOrBlockRequest) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"blocked",
		"reason",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varActivateOrBlockRequest := _ActivateOrBlockRequest{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varActivateOrBlockRequest)

	if err != nil {
		return err
	}

	*o = ActivateOrBlockRequest(varActivateOrBlockRequest)

	return err
}

type NullableActivateOrBlockRequest struct {
	value *ActivateOrBlockRequest
	isSet bool
}

func (v NullableActivateOrBlockRequest) Get() *ActivateOrBlockRequest {
	return v.value
}

func (v *NullableActivateOrBlockRequest) Set(val *ActivateOrBlockRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableActivateOrBlockRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableActivateOrBlockRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActivateOrBlockRequest(val *ActivateOrBlockRequest) *NullableActivateOrBlockRequest {
	return &NullableActivateOrBlockRequest{value: val, isSet: true}
}

func (v NullableActivateOrBlockRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActivateOrBlockRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
